package com.example.patrice.rerservation01;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import org.apache.http.NameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;

public class database_jeu extends ListActivity
{
    private ProgressDialog pDialog;

    JSONParser jParser = new JSONParser();

    ArrayList<HashMap<String, String>> liste_jeux;

    private static String url_all_products = "http://analog-design.net/WORKAREA/WEBSITE/reservation/test_db.php";

    // JSON Node names
    private static final String TAG_SUCCESS = "success";
    private static final String TAG_PRODUCTS = "products";
    private static final String TAG_ID = "id";
    private static final String TAG_NAME = "nom";

    public static final String EXTRA_STRING_NAME = "extraStringName";

    // products JSONArray
    JSONArray products = null;

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.list_all_elements);

        // Hashmap for ListView
        liste_jeux = new ArrayList<HashMap<String, String>>();

        Toast.makeText(getApplicationContext(),  "coucou ..." , Toast.LENGTH_SHORT).show();

        new charger_liste_jeux_db().execute();

        ListView lv = getListView();

        lv.setOnItemClickListener(new OnItemClickListener()
        {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id)
            {
                String pid = ((TextView) view.findViewById(R.id.pid)).getText().toString();
                TextView v = (TextView) view.findViewById(R.id.name);

                CharSequence jeu_selection = v.getText();
                pullFxn((String) jeu_selection);

                Toast.makeText(getApplicationContext(), "Click" + v.getText(), Toast.LENGTH_LONG).show();
                //Intent in = new Intent(getApplicationContext(), selection_jeu.class);
                //in.putExtra(TAG_ID, v.getText() );
                //startActivityForResult(in, 100);
            }
        });

    }

    private void pullFxn(String jeu_selection)
    {
        Intent iData = new Intent();
        iData.putExtra( EXTRA_STRING_NAME, jeu_selection );
        setResult( android.app.Activity.RESULT_OK, iData );
        finish();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        super.onActivityResult(requestCode, resultCode, data);
        // if result code 100
        if (resultCode == 100)
        {
            // if result code 100 is received
            // means user edited/deleted product
            // reload this screen again
            Intent intent = getIntent();
            finish();
            startActivity(intent);
        }

    }

    class charger_liste_jeux_db extends AsyncTask<String, String, String>
    {
        @Override
        protected void onPreExecute()
        {
            super.onPreExecute();
            pDialog = new ProgressDialog(database_jeu.this);
            pDialog.setMessage("Consultation de la database des jeux. Patience ...");
            pDialog.setIndeterminate(false);
            pDialog.setCancelable(false);
            pDialog.show();
        }

        protected String doInBackground(String... args)
        {
            List<NameValuePair> params = new ArrayList<NameValuePair>();
            JSONObject json = jParser.makeHttpRequest(url_all_products, "GET", params);

            Log.d("Tous les jeux: ", json.toString());

            try
            {
                // Checking for SUCCESS TAG
                int success = json.getInt(TAG_SUCCESS);

                if (success == 1)
                {
                    // products found
                    // Getting Array of Products
                    products = json.getJSONArray(TAG_PRODUCTS);

                    // looping through All Products
                    for (int i = 0; i < products.length(); i++)
                    {
                        JSONObject c = products.getJSONObject(i);

                        // Storing each json item in variable
                        String id = c.getString(TAG_ID);
                        String name = c.getString(TAG_NAME);

                        // creating new HashMap
                        HashMap<String, String> map = new HashMap<String, String>();

                        // adding each child node to HashMap key => value
                        map.put(TAG_ID, id);
                        map.put(TAG_NAME, name);

                        // adding HashList to ArrayList
                        liste_jeux.add(map);
                    }
                }
                else
                {
                    // pas de jeux dans la base de données !
                }
            }

            catch (JSONException e)
            {
                e.printStackTrace();
            }

            return null;
        }

        protected void onPostExecute(String file_url)
        {

            pDialog.dismiss();
            // updating UI from Background Thread
            runOnUiThread(new Runnable()
            {
                public void run()
                {
                    /**
                     * Updating parsed JSON data into ListView
                     * */
                    ListAdapter adapter = new SimpleAdapter(database_jeu.this, liste_jeux, R.layout.liste_jeux_row_layout, new String[]
                            { TAG_ID,  TAG_NAME},    new int[] { R.id.pid, R.id.name });

                    // updating listview
                    setListAdapter(adapter);
                }
            });
        }
    }
}